#include "headers.h"

float	fps;
char	text[20];
Camera		c;
Stereo		st(1);
/*	Pouzivane klavesy:
	mys sipky, Page Up, Page Down - pohyb v priestore
	Q,W - zmena ohniskovej vzdialenosti
	Y - zaostrenie
	U - automaticke zaostrovanie
	Z,X - zmena separacie oci
	I,O - nastavuje posunutie obrazkov v bezokuliarovaom mode
	E - reset stereo nastaveni
	S - vypne stereo
	D - prepina medzi modom s farebnymi okuliarmy a modom bez farebnych okuliarov
	J,K - zobrazi iba pravy, lavy pohlad
	R - reset pohladu
	H - help		*/

Timer   timer0;
float uhol_x,uhol_y,uhol_z;

void DrawGLScene_stereo(void)
{
/*	glBegin(GL_LINES);			// kreslime osi
		glVertex3f(-0.5f,0,0);
		glVertex3f(5,0,0);

		glVertex3f(0,-0.5f,0);
		glVertex3f(0,5,0);

		glVertex3f(0,0,-0.5f);
		glVertex3f(0,0,5);
	glEnd();
*/
/*	c.Push();
	glRotatef(uhol_x,1,0,0);
	glRotatef(uhol_y,0,1,0);
	glRotatef(uhol_z,0,0,1);
*/	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_QUADS);		//kreslime kocku
		
		glVertex3f(-0.5f, -1.0f,  3.0f);
		glVertex3f( 0.5f, -1.0f,  3.0f);
		glVertex3f( 1.0f,  1.0f,  1.0f);
		glVertex3f(-1.0f,  1.0f,  1.0f);	
			
		// Front Face
		glVertex3f(-1.0f, -1.0f,  1.0f);
		glVertex3f( 1.0f, -1.0f,  1.0f);
		glVertex3f( 1.0f,  1.0f,  1.0f);
		glVertex3f(-1.0f,  1.0f,  1.0f);
		// Back Face
		glVertex3f(-1.0f, -1.0f, -1.0f);
		glVertex3f(-1.0f,  1.0f, -1.0f);
		glVertex3f( 1.0f,  1.0f, -1.0f);
		glVertex3f( 1.0f, -1.0f, -1.0f);
		// Top Face
		glVertex3f(-1.0f,  1.0f, -1.0f);
		glVertex3f(-1.0f,  1.0f,  1.0f);
		glVertex3f( 1.0f,  1.0f,  1.0f);
		glVertex3f( 1.0f,  1.0f, -1.0f);
		// Bottom Face
		glVertex3f(-1.0f, -1.0f, -1.0f);
		glVertex3f( 1.0f, -1.0f, -1.0f);
		glVertex3f( 1.0f, -1.0f,  1.0f);
		glVertex3f(-1.0f, -1.0f,  1.0f);
		// Right face
		glVertex3f( 1.0f, -1.0f, -1.0f);
		glVertex3f( 1.0f,  1.0f, -1.0f);
		glVertex3f( 1.0f,  1.0f,  1.0f);
		glVertex3f( 1.0f, -1.0f,  1.0f);
		// Left Face
		glVertex3f(-1.0f, -1.0f, -1.0f);
		glVertex3f(-1.0f, -1.0f,  1.0f);
		glVertex3f(-1.0f,  1.0f,  1.0f);
		glVertex3f(-1.0f,  1.0f, -1.0f);
	glEnd();
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
/*	c.Pop();
	c.d();
*/
}


void DrawGLScene(void)				// vlastn kreslenie
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	
	//glLineWidth(5.0f);			// hrubka ciar
	glDisable(GL_TEXTURE_2D);		// vypnem texturovanie
	glEnable(GL_BLEND);				// zapnem miesanie farieb
	
	c.MoveWorld();					// otocenie sveta
	
	st.Update(c.Distance());		// nastavenie stereo pomocou klavesnice
	if(keys['Y']) st.Set(c.Distance());
	if(keys['E'])					// reset nastavenie stereo
	{
		st.posuv = 0;
		st.sep = 30.0f;
		st.Set(c.Distance());
	}
	
	if(!keys['S'])
	{
		// ----------- Lave oko --------------------------------------
		st.LeftEye();					// nastavenie projekcnej matice pre lave oko
		if(!keys['J'])DrawGLScene_stereo();			// vykreslenie sceny
		
		// ----------- Prave oko -------------------------------------
		glClear(GL_DEPTH_BUFFER_BIT);	// znulovanie z buffera
		st.RightEye();					// nastavenie kreslenia pre prave oko
		if(!keys['K'])DrawGLScene_stereo();			// vykreselie seceny
		
		st.Center();					// nastavenie normalenho (ne stereo) kreslenia
	}
	else DrawGLScene_stereo();

	glDisable(GL_BLEND);			// vypnem miesenia farieb
	glEnable(GL_TEXTURE_2D);		// zapnem texturovanie
	glColor3f(1,1,1);
	font0->Begin();

	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	gcvt( (double)fps, 4, text);
	font0->Print(0,0,text,0);

	if(keys['H'])				//vypise help
	{
		font0->Print(15,7,"Program: Stereographic viewing 01",0);
		glColor3f(0.9f,0.9f,1.0f);
		font0->Print(8,8,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
		glColor3f(1.0f,1.0f,1.0f);
		font0->Print(10,9,"Controls:",1);
		font0->Print(15,10,"mouse, arrows, Page Up, Page Down - moving",1);
		font0->Print(15,11,"U - automatic focus",1);
		font0->Print(15,12,"Q,W - change focal length",1);
		font0->Print(15,13,"Y - focus",1);
		font0->Print(15,14,"Z,X - change separation of eyes",1);
		font0->Print(15,15,"E - reset stereo setting",1);
		font0->Print(15,16,"S - switch off stereo",1);
		font0->Print(15,17,"D - switch between glasses mode and witout glasses mode",1);
		font0->Print(15,18,"I,O - set shift pictures in without glasses mode",1);
		font0->Print(15,19,"J,K - show only right, left view",1);		
		font0->Print(15,20,"R - reset camera",1);
		font0->Print(15,21,"H - help",1);
	}
	font0->End();

	uhol_x += 0.1f;
	uhol_y += 0.2f;
	uhol_z += 0.3f;
}