#include "timer.h"

Timer::Timer(void)									// inicializcia asovaa
{
	mm_timer_start = 0;
	performance_timer_start = 0;

	// zistenie i rchli asova je pouiten
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &(frekvencia) ))
	{
		// rchli asova nepodporovan hardwarom
		performance_timer	= FALSE;					// nastav Performance Timer na false
		mm_timer_start		= timeGetTime();			// pouitm timeGetTime() nastav tartovaciu hodnotu
		perioda				= 1.0f/1000.0f;				// nastav periodu na 1 ms
		frekvencia			= 1000;						// nastav frekvenciu na 1000 Hz
	}
	else
	{
		// rchli asova je prstupn
		QueryPerformanceCounter((LARGE_INTEGER *) &(performance_timer_start) );	//nastavenie tartovacej hodnoty
		performance_timer	= TRUE;				// nastav Performance Timer na TRUE
		perioda = (float) (1.0/((double)frekvencia));	// vypotanie peridy
	}
}

float Timer::GetTime(void)					// vrti as v sekundch
{
	__int64 time;									// na uloenie aktulnej hodnoty asovaa

	if (performance_timer)					// je pouit rchli asova (Performance Timer ) ?
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &time);	// natanie aktulnej hodnoty asovaa
		// vrti aktulnu hodnotu minus tartovaciu hodnotu nasoben peridou
		return ( (float) ( time - performance_timer_start) * perioda);
	}
	else
	{	return( (float) ( timeGetTime() - mm_timer_start) * perioda);}	// vrti poet seknd od tartu
}

void Timer::Reset(void)
{	
	if (performance_timer)					// je pouit rchli asova (Performance Timer ) ?
	{	QueryPerformanceCounter((LARGE_INTEGER *) &(performance_timer_start) );}
	else
	{	mm_timer_start = timeGetTime();}
}